/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package spring.springmvstepbystep.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.format.FormatterRegistry;
import org.springframework.web.servlet.View;
import org.springframework.web.servlet.ViewResolver;
import org.springframework.web.servlet.config.annotation.EnableWebMvc;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;
import org.springframework.web.servlet.view.BeanNameViewResolver;
import org.springframework.web.servlet.view.JstlView;
import org.springframework.web.servlet.view.UrlBasedViewResolver;
import spring.springmvstepbystep.domen.City;
import spring.springmvstepbystep.formatter.CityFormatter;

/**
 *
 * @author user
 */
//@Configuration
@ComponentScan(basePackages = "spring.springmvstepbystep")
@EnableWebMvc
public class StepByStepMvcConfiguration extends WebMvcConfigurerAdapter {

    /**
     * ***************************************************************************************
     * HandlerMapping: default defined @EnableWebMvc
     */
//    @Bean
//    public RequestMappingHandlerMapping requestMappingHandlerMapping() {
//        System.out.println("***************** requestMappingHandlerMapping **************");
//        RequestMappingHandlerMapping mapping = new RequestMappingHandlerMapping();
//        return mapping;
//    }

    /**
     * ***************************************************************************************
     * ViewResolver
     */
//    @Bean
//    public InternalResourceViewResolver jspViewResolver() {
//        System.out.println("@Bean****************jspViewResolver*******************");
//        InternalResourceViewResolver bean = new InternalResourceViewResolver();
//        bean.setOrder(2);
//        bean.setPrefix("/WEB-INF/views/");
//        bean.setSuffix(".jsp");
//        return bean;
//    }

    /* BeanNameViewResolver */
    @Bean
    public ViewResolver beanNameViewResolver() {
        System.out.println("@Bean********************** beanNameViewResolver **********************");
        BeanNameViewResolver viewResolver = new BeanNameViewResolver();
        viewResolver.setOrder(1);
        return viewResolver;
    }

    @Bean (name = "start")
    public View start() {
        JstlView view = new JstlView();
        view.setUrl("/pages/start.jsp");
        return view;
    }

    @Bean
    public View addCity() {
        JstlView view = new JstlView();
        view.setUrl("/WEB-INF/views/addCity.jsp");
        return view;
    }

    /* UrlBasedViewResolver */
    @Bean
    public ViewResolver urlBasedViewResolver() {
        System.out.println("@Bean****************urlBasedViewResolver*******************");
        UrlBasedViewResolver viewResolver = new UrlBasedViewResolver();
        viewResolver.setOrder(2);
        viewResolver.setPrefix("/WEB-INF/views/");
        //viewResolver.setPrefix("/pages/");
        viewResolver.setSuffix(".jsp");
        viewResolver.setViewClass(JstlView.class);
        return viewResolver;
    }
    
    @Override
    public void addFormatters(FormatterRegistry registry) {
        registry.addFormatterForFieldType(City.class, new CityFormatter());
    }
}
