<%@taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@taglib prefix="spring" uri="http://www.springframework.org/tags" %>

<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>

<c:if test="${exception ne null}">
    <div class="error">${exception.message}</div>
</c:if>

<form:form method="post" modelAttribute="company" action="../company/save">
    <fieldset>
        <legend>Register new company</legend>
        <table>
            <tr>
                <td><form:label path="name">Name</form:label></td>
                <td><form:input path="name"/></td>
                <td><form:errors path="name"/></td>
            </tr>
            <tr>                
                <td colspan="3">
                    <fieldset>
                        <legend>Adress</legend>
                        <table>
                            <tr>
                                <td><form:label path="address.street">Street</form:label></td>
                                <td><form:input path="address.street"/></td>
                            </tr>
                            <tr>
                                <td><form:label path="address.streetNo">Street number</form:label></td>
                                <td><form:input path="address.streetNo"/></td>
                            </tr>     
                            <tr>                
                                <td colspan="2">
                                    <fieldset>
                                        <legend>City</legend>
                                        <table>
                                            <tr>
                                                <td><form:label path="address.city">City</form:label></td>
                                                    <td>
                                                    <form:select path="address.city">
                                                        <form:option value="0" label="Select One" />
                                                        <form:options items="${cities}" itemValue="postNumber" itemLabel="name" />
                                                    </form:select>
                                                </td>
                                            </tr>
                                        </table>
                                    </fieldset>
                                </td>    
                            </tr>
                        </table>
                    </fieldset>
                </td>    
            </tr>
            <tr><td colspan="2" align="center">
                    <button id="login">Save</button>
                </td></tr>
        </table>
    </fieldset>
</form:form>